using System;
using System.ComponentModel;

namespace FeatureVoting {
	public class Feature : INotifyPropertyChanged {
		public Feature( ) {
		}

		public Feature(string name) {
			this.name = name;
		}

		private string name;
		public string Name {
			get {
				return name;
			}
		}

		#region INotifyPropertyChanged Members

		PropertyChangedEventHandler propertyChangedEventHandler;

		public void RaisePropertyChanged(string propertyName) {
			propertyChangedEventHandler.Invoke(this, new PropertyChangedEventArgs(propertyName));
		}

		event PropertyChangedEventHandler INotifyPropertyChanged.PropertyChanged {
			add { propertyChangedEventHandler += value; }
			remove { propertyChangedEventHandler -= value; }
		}

		#endregion
	}
}