using System;
using System.ComponentModel;

namespace FeatureVoting {
	public class Vote : INotifyPropertyChanged {
		public Vote( ) {

		}

		public Vote(Feature feature, int year, int priority) {
			this.feature = feature;
			this.year = year;
			this.priority = priority;
		}

		private Feature feature;
		public Feature Feature {
			get {
				return feature;
			}
			set {
				feature = value;
			}
		}

		private int year;
		public int Year {
			get {
				return year;
			}
			set {
				year = value;
			}
		}

		private int priority;
		public int Priority {
			get {
				return priority;
			}
			set {
				if (priority != value) {
					priority = value;
					RaisePropertyChanged("Priority");
				}
			}
		}

		#region INotifyPropertyChanged Members

		PropertyChangedEventHandler propertyChangedEventHandler;

		private void RaisePropertyChanged(string propertyName) {
			propertyChangedEventHandler.Invoke(this, new PropertyChangedEventArgs(propertyName));
		}

		event PropertyChangedEventHandler INotifyPropertyChanged.PropertyChanged {
			add { propertyChangedEventHandler += value; }
			remove { propertyChangedEventHandler -= value; }
		}

		#endregion
	}
}
