using System;
using System.Windows.Forms;
using System.ComponentModel;

namespace FeatureVoting {
	public class VoteValueCell : DataGridViewTextBoxCell {
		public VoteValueCell( ) {

		}

		public override void InitializeEditingControl(int rowIndex, object initialFormattedValue, DataGridViewCellStyle dataGridViewCellStyle) {
			base.InitializeEditingControl(rowIndex, initialFormattedValue, dataGridViewCellStyle);

			VoteValuePropertyDescriptor propertyDescriptor = (VoteValuePropertyDescriptor)
				((ITypedList) DataGridView.DataSource).GetItemProperties(null)[DataGridView.Columns[this.ColumnIndex].DataPropertyName];
			int voteValue = (int) this.Value;
			int remainingVoteValue = Math.Max(100 - propertyDescriptor.CalcPrioritySumForYear( ) + voteValue, 0);
			
			VoteValueEditingControl control = (VoteValueEditingControl) DataGridView.EditingControl;
			control.ResetControl(voteValue, remainingVoteValue);
		}

		public override Type EditType {
			get {
				return typeof(VoteValueEditingControl);
			}
		}

		public override Type ValueType {
			get {
				return typeof(int);
			}
		}

		public override object DefaultNewRowValue {
			get {
				return 0;
			}
		}
	}
}
