using System;
using System.Windows.Forms;

namespace FeatureVoting {
	public class VoteValueColumn : DataGridViewColumn {
		public VoteValueColumn( )
			: base(new VoteValueCell( )) {
		}

		public override DataGridViewCell CellTemplate {
			get {
				return base.CellTemplate;
			}
			set {
				if (value != null &&
					!value.GetType( ).IsAssignableFrom(typeof(VoteValueCell))) {
					throw new InvalidCastException("Cell must be of type VoteValueCell");
				}
				base.CellTemplate = value;
			}
		}
	}
}
