using System;
using System.Windows.Forms;

namespace FeatureVoting {
	public class VoteValueEditingControl : VoteValueEditor, IDataGridViewEditingControl {
		public VoteValueEditingControl( ) {

		}

		protected override void OnValueChanged(EventArgs eventArgs) {
			valueChanged = true;
			dataGridView.NotifyCurrentCellDirty(true);
			base.OnValueChanged(eventArgs);
		}

		#region IDataGridViewEditingControl Members

		void IDataGridViewEditingControl.ApplyCellStyleToEditingControl(DataGridViewCellStyle dataGridViewCellStyle) {

		}

		DataGridView dataGridView;
		DataGridView IDataGridViewEditingControl.EditingControlDataGridView {
			get {
				return dataGridView;
			}
			set {
				dataGridView = value;
			}
		}

		object IDataGridViewEditingControl.EditingControlFormattedValue {
			get {
				return Value.ToString( );
			}
			set {
				string strVal = value as string;
				if (strVal != null)
					Value = int.Parse(strVal);
			}
		}

		int rowIndex;
		int IDataGridViewEditingControl.EditingControlRowIndex {
			get {
				return rowIndex;
			}
			set {
				rowIndex = value;
			}
		}

		bool valueChanged;
		bool IDataGridViewEditingControl.EditingControlValueChanged {
			get {
				return valueChanged;
			}
			set {
				valueChanged = value;
			}
		}

		bool IDataGridViewEditingControl.EditingControlWantsInputKey(Keys keyData, bool dataGridViewWantsInputKey) {
			return keyData == Keys.Left || keyData == Keys.Right;
		}

		Cursor IDataGridViewEditingControl.EditingPanelCursor {
			get { return base.Cursor; }
		}

		object IDataGridViewEditingControl.GetEditingControlFormattedValue(DataGridViewDataErrorContexts context) {
			return ((IDataGridViewEditingControl) this).EditingControlFormattedValue;
		}

		void IDataGridViewEditingControl.PrepareEditingControlForEdit(bool selectAll) {

		}

		bool IDataGridViewEditingControl.RepositionEditingControlOnValueChange {
			get { return false; }
		}

		#endregion
	}
}
