using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace FeatureVoting {
	public partial class VoteValueEditor : UserControl {
		public VoteValueEditor( ) {
			InitializeComponent( );

			ResetControl(0, 100);
		}

		public void ResetControl(int initialValue, int maxValidValue) {
			trackBar.DataBindings.Clear( );
			valueLabel.DataBindings.Clear( );

			this.maxValidValue = maxValidValue;
			value = initialValue;
			EvaluateValueValidity( );

			trackBar.DataBindings.Add("Value", this, "Value", false, DataSourceUpdateMode.OnPropertyChanged);
			valueLabel.DataBindings.Add("Text", this, "Value");
		}

		private int value;
		public int Value {
			get {
				return value;
			}
			set {
				this.value = value;
				EvaluateValueValidity( );
				OnValueChanged(EventArgs.Empty);
			}
		}

		private int maxValidValue;
		public int MaxValidValue {
			get {
				return maxValidValue;
			}
			set {
				maxValidValue = value;
				EvaluateValueValidity( );
			}
		}

		private void EvaluateValueValidity( ) {
			this.BackColor = value <= maxValidValue ? SystemColors.Control : Color.Red;
		}

		public EventHandler<EventArgs> ValueChanged;

		protected virtual void OnValueChanged(EventArgs eventArgs) {
			if (ValueChanged != null)
				ValueChanged(this, eventArgs);
		}
	}
}
