using System;
using System.ComponentModel;
using System.Collections;
using System.Collections.Generic;

namespace Sturm.CollectionWrapping {
	/// <summary>
	/// This wrapper implements IBindingList, for all such implementations.
	/// </summary>
	public class TypedListWrapperIBindingList : TypedListWrapperIList, IBindingList {
		public TypedListWrapperIBindingList( ) {

		}

		public TypedListWrapperIBindingList(IBindingList wrappedIBindingList) {
			this.wrappedIBindingList = wrappedIBindingList;
		}

		public TypedListWrapperIBindingList(IBindingList wrappedIBindingList, PropertyDescriptorCollection propertyDescriptorCollection)
			: base(propertyDescriptorCollection) {
			this.wrappedIBindingList = wrappedIBindingList;
		}

		public TypedListWrapperIBindingList(PropertyDescriptorCollection propertyDescriptorCollection)
			: base(propertyDescriptorCollection) {
		}

		private IBindingList wrappedIBindingList;
		public IBindingList WrappedIBindingList {
			get {
				return wrappedIBindingList;
			}
			set {
				wrappedIBindingList = value;
			}
		}

		#region IBindingList Members

		void IBindingList.AddIndex(PropertyDescriptor property) {
			wrappedIBindingList.AddIndex(property);
		}

		object IBindingList.AddNew( ) {
			return wrappedIBindingList.AddNew( );
		}

		bool IBindingList.AllowEdit {
			get { return wrappedIBindingList.AllowEdit; }
		}

		bool IBindingList.AllowNew {
			get { return wrappedIBindingList.AllowNew; }
		}

		bool IBindingList.AllowRemove {
			get { return wrappedIBindingList.AllowRemove; }
		}

		void IBindingList.ApplySort(PropertyDescriptor property, ListSortDirection direction) {
			wrappedIBindingList.ApplySort(property, direction);
		}

		int IBindingList.Find(PropertyDescriptor property, object key) {
			return wrappedIBindingList.Find(property, key);
		}

		bool IBindingList.IsSorted {
			get { return wrappedIBindingList.IsSorted; }
		}

		event ListChangedEventHandler IBindingList.ListChanged {
			add { wrappedIBindingList.ListChanged += value; }
			remove { wrappedIBindingList.ListChanged -= value; }
		}

		void IBindingList.RemoveIndex(PropertyDescriptor property) {
			wrappedIBindingList.RemoveIndex(property);
		}

		void IBindingList.RemoveSort( ) {
			wrappedIBindingList.RemoveSort( );
		}

		ListSortDirection IBindingList.SortDirection {
			get { return wrappedIBindingList.SortDirection; }
		}

		PropertyDescriptor IBindingList.SortProperty {
			get { return wrappedIBindingList.SortProperty; }
		}

		bool IBindingList.SupportsChangeNotification {
			get { return wrappedIBindingList.SupportsChangeNotification; }
		}

		bool IBindingList.SupportsSearching {
			get { return wrappedIBindingList.SupportsSearching; }
		}

		bool IBindingList.SupportsSorting {
			get { return wrappedIBindingList.SupportsSorting; }
		}

		#endregion
	}

}
